//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.09.22
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#include <time.h>
#include "saori.h"
#include "time_main.h"
#include "def.h"



int time_main(Saori_data *saoridata)
{
	int ret;
	string setipath;
	int exec_ret;

	time_t long_time;
	struct tm *newtime;

	ret = 0;
	exec_ret = 0;
	
	if((saoridata->get_argument(0)).compare(COMMAND_CHECK_EXPIRATION)==0){
		// ͂ꂽo߂𒲂ׂ
		int year , input_year;
		int month , input_month;
		int day , input_day;
		int hour , input_hour;
		int min , input_min;
		int sec , input_sec;
		
		
		time(&long_time);
		newtime = localtime(&long_time);
		
		input_year = atoi(saoridata->get_argument(1).c_str());
		input_month = atoi(saoridata->get_argument(2).c_str());
		input_day = atoi(saoridata->get_argument(3).c_str());
		input_hour = atoi(saoridata->get_argument(4).c_str());
		input_min = atoi(saoridata->get_argument(5).c_str());
		input_sec = atoi(saoridata->get_argument(6).c_str());

		year = (int)(newtime->tm_year + 1900);
		month = (int)(newtime->tm_mon + 1);
		day = (int)(newtime->tm_mday);
		hour = (int)(newtime->tm_hour);
		min = (int)(newtime->tm_min);
		sec = (int)(newtime->tm_sec);
		
		
		if(year > input_year){
//			exec_ret = 1;
			exec_ret = RET_PAST;				// ߋ
		}else if(year == input_year){
			if(month > input_month){
//				exec_ret = 2;
				exec_ret = RET_PAST;				// ߋ
			}else if(month == input_month){
				if(day > input_day){
//					exec_ret = 3;
					exec_ret = RET_PAST;				// ߋ
				}else if(day == input_day){
					if(hour > input_hour){
//						exec_ret = 4;
						exec_ret = RET_PAST;				// ߋ
					}else if(hour == input_hour){
						if(min > input_min){
//							exec_ret = 5;
							exec_ret = RET_PAST;				// ߋ
						}else if(min == input_min){
							if(sec > input_sec){
//								exec_ret = 6;
								exec_ret = RET_PAST;				// ߋ
							}else if(sec == input_sec){
//								exec_ret = 7;
								exec_ret = RET_PRESENT;
							}
						}else{
//							exec_ret = 8;
							exec_ret = RET_FUTURE;
						}
					}else{
//						exec_ret = 9;
						exec_ret = RET_FUTURE;
					}
				}else{
//					exec_ret = 10;
					exec_ret = RET_FUTURE;
				}
			}else{
//				exec_ret = 11;
				exec_ret = RET_FUTURE;
			}
		}else{
//			exec_ret = 12;
			exec_ret = RET_FUTURE;
		}

/*		
		char tmp[32];
		sprintf(tmp,"%d",year);
		saoridata->set_result(tmp);
		
		sprintf(tmp,"%d",input_year);
		saoridata->set_value(tmp,0);
		
		sprintf(tmp,"%d",exec_ret);
		saoridata->set_value(tmp,1);
*/
		if(exec_ret == RET_FUTURE){
			saoridata->set_result("future");
		}else if(exec_ret == RET_PAST){
			saoridata->set_result("past");
		}else{
			saoridata->set_result("present");
		}
		ret = 200;
	
	}else if((saoridata->get_argument(0)).compare(COMMAND_MAKE_EXPIRATION)==0){
		// ͂ꂽԂo߂Ԃ
		
		int input_day;
		int input_hour;
		int input_min;
		char tmp[32];
		
		input_day = atoi((saoridata->get_argument(1)).c_str());
		input_hour = atoi((saoridata->get_argument(2)).c_str());
		input_min = atoi((saoridata->get_argument(3)).c_str());
		
		time(&long_time);
		long_time += (long)((input_day * 86400) + (input_hour * 3600) + (input_min * 60));
		newtime = localtime(&long_time);
		
		sprintf(tmp,"%d",long_time);
		saoridata->set_result(tmp);
		
		sprintf(tmp,"%d",(int)(newtime->tm_year + 1900));
		saoridata->set_value(tmp,0);
		
		sprintf(tmp,"%d",(int)(newtime->tm_mon + 1));
		saoridata->set_value(tmp,1);
		
		sprintf(tmp,"%d",(int)(newtime->tm_mday));
		saoridata->set_value(tmp,2);
		
		sprintf(tmp,"%d",(int)(newtime->tm_hour));
		saoridata->set_value(tmp,3);
		
		sprintf(tmp,"%d",(int)(newtime->tm_min));
		saoridata->set_value(tmp,4);
		
		sprintf(tmp,"%d",(int)(newtime->tm_sec));
		saoridata->set_value(tmp,5);
		
		ret = 200;
	
	}else if((saoridata->get_argument(0)).compare(COMMAND_HOW_MANY_DAYS)==0){
		// ͂ꂽ܂ŉ邩Ԃ
		
		int year;
		int month;
		int day;
		int input_mjd;
		int today_mjd;
		char tmp[32];
		
		year = atoi(saoridata->get_argument(1).c_str());
		month = atoi(saoridata->get_argument(2).c_str());
		day = atoi(saoridata->get_argument(3).c_str());
		
		input_mjd = make_mjd(year,month,day);
		
		time(&long_time);
		newtime = localtime(&long_time);
		
		year = (int)(newtime->tm_year + 1900);
		month = (int)(newtime->tm_mon + 1);
		day = (int)(newtime->tm_mday);
		
		today_mjd = make_mjd((int)(newtime->tm_year + 1900),(int)(newtime->tm_mon + 1),(int)(newtime->tm_mday));
		
		sprintf(tmp,"%d",input_mjd-today_mjd);
		saoridata->set_value(tmp,0);
		sprintf(tmp,"%d",input_mjd);
		saoridata->set_value(tmp,1);
		sprintf(tmp,"%d",today_mjd);
		saoridata->set_value(tmp,2);
		
		ret = 200;
	
	}else{
		ret = 400;
	}
		
	cout << "ret: "<< ret << ": exec_ret: " << exec_ret << "\n";
	

	return(ret);
}

int make_mjd(int year,int month,int day)
{
	int mjd;

	if(month < 3){
		month += 12;
		year--;
	}
	
	// t[Q̌
	mjd = (int)(365.25 * (double)year) + int(year / 400) - int(year / 100) + int(30.59 * (double)(month - 2)) + day - 678912;

	return(mjd);
}
