/****************************************************************** MSW *****/
/*  <NAME>      setimon.c                                                   */
/*  <FUNCTION>  setimon main                                                */
/*                                                                          */
/*                          <CREATE> 99/08/04   <CODED BY> T.Hayashi        */
/*  Copyright (C) 1999 T.Hayashi All Rights Reserved                        */
/****************************************************************************/
/*

 <Program modify list>

 <Details Function>
	main

 <Reference Program>
	none

 <Machine>              PC-AT
 <CPU>                  Intel 386
 <OS>                   PC-DOS
 <Language>             C
 <Compiler/Assembler>   BC++ Ver.4.0
*/

#include "setimon.h"


main(int argc,char **argv)
{

	struct local localdata;			/* setimonɊւdata */
	struct state status;			/*  */
	struct opt option;				/* R}hCIvV */

	FILE *fp_cfg;
	char *fget_err;					/* fgets error check flg */
	char buffer[Buffer_size];

	char hostname[Buffer_size];		/* SETI@homeHOST */
	char setipath[Buffer_size];		/* cfgɒ`ꂽpath */
//	char setipath2[Buffer_size];	/* seti@homepath */
	
//	int seti_ver;					/* SETI@homeNCAg̃o[W */
//	char pathwork[Buffer_size];		/* fileL̃`FbNp */
	
	time_t begin,end;				/* ҂Ԍvp */
	
	int count;
	int stl;
	

	local_reset(&localdata);
	state_reset(&status);

	option_reset(&option);
	if(argc > 1){
		check_cmdlin(argc, argv, &option);
	}else{							/* 1񂾂\ */
		option.view = ON;
		option.loop = OFF;
	}

	if(option.co_version == ON){
		printf("Setimon Version %s\n",localdata.setimon_version);
	}
	
	while(option.view){
		if(option.loop == OFF){
			option.view = OFF;
		}

		if((fp_cfg=fopen("setimon.cfg","rt"))==NULL){
			printf("setimon.cfg open error!!\n");
		}else{

			do{
				fget_err=fgets(buffer,Buffer_size,fp_cfg);			/* 1sǂݍ */
				if(fget_err!=NULL){
					if((buffer[0]!='#')&&(buffer[0]!='\0')&&(buffer[0]!='\n')&&(buffer[0]!=';')){
						getword(buffer,hostname);			/* seti@homeHOST擾 */
						getword(buffer,setipath);			/* seti@homepath擾 */
						
						stl = strlen(setipath);
						for(count=0;count<=stl;count++){
							if( (setipath[stl - count] == '\\') || (setipath[stl - count] == '/')){
								setipath[stl - count+1] = '\0';
								break;
							}
						}

						if((option.co_host == OFF)						/* HOSTNAMEwȂ */
						|| (strcmp(hostname,option.hostname) == 0) ){	/* HOSTNAMEv */
							
							filecheck(setipath,&status,hostname);
							makeoutdata(status,option,&localdata,hostname);	/* data output */
							output(status,option,localdata);
						}
					}
				}
			}while(fget_err!=NULL);
			(void)fclose(fp_cfg);
			printf("\n");
	
	/* -timeIvVp */
			time(&begin);
			do{
				time(&end);
			}while(difftime(end,begin) < option.wait_time);
	/*  */
//			printf("time %ld:%ld\n",begin,end);
//			sleep(option.wait_time);
		}
	
	}
	
	return(0);
}

