//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.09.22
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#include "saori.h"
#include "def.h"
#include "nasino_dic.h"
#include "sstp_main.h"
#include "sstp_send.h"


int sstp_main(Saori_data *saoridata)
{
	int ret;
	string setipath;
	int exec_ret;

	ret = 0;
	exec_ret = 0;
	if((saoridata->get_argument(0)).size() == 0){
		// s
		ret = 500;
		
	}else if((saoridata->get_argument(0)).compare(COMMAND_BASIC)==0){
		// BASIC
		if(sstp_send(saoridata->get_argument(0),atoi((saoridata->get_argument(1)).c_str()),saoridata->get_argument(2)) == OK){
			ret = 200;
//			saoridata->set_result(setimon.get_unitdata(DATA_CLIENT_VERSION));
		}else{
			ret = 500;
		}
	
	}else if((saoridata->get_argument(0)).compare(COMMAND_ADVANCED)==0){
		// Advanced
		if(sstp_send(saoridata->get_argument(0),atoi((saoridata->get_argument(1)).c_str()),saoridata->get_argument(2)) == OK){
			ret = 200;
//			saoridata->set_result(setimon.get_unitdata(DATA_CLIENT_VERSION));
		}else{
			ret = 500;
		}
	
	}else if((saoridata->get_argument(0)).compare(COMMAND_TEST)==0){
		// Advanced
		if(sstp_send("",9801,"NOTIFY SSTP/1.0\r\nSender: \r\nEvent: OnFirstBoot\r\nCharset: Shift_JIS\r\n\r\n") == OK){
			ret = 200;
//			saoridata->set_result(setimon.get_unitdata(DATA_CLIENT_VERSION));
		}else{
			ret = 500;
		}
	
	}else{
		ret = 400;
	}
		
	cout << "ret: "<< ret << ": exec_ret: " << exec_ret << "\n";
	

	return(ret);
}


